=== debian/control ===
Source: ros-lunar-rtabmap
Section: misc
Priority: extra
Maintainer: Mathieu Labbe <matlabbe@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libfreenect-dev, libopenni-dev, libpcl-dev, libproj-dev, libsqlite3-dev, libvtk6-qt-dev, ros-lunar-cv-bridge, ros-lunar-libg2o, ros-lunar-octomap, ros-lunar-qt-gui-cpp, zlib1g-dev
Homepage: http://introlab.github.io/rtabmap
Standards-Version: 3.9.2

Package: ros-lunar-rtabmap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfreenect-dev, libopenni-dev, libpcl-dev, libsqlite3-dev, libvtk6-qt-dev, ros-lunar-cv-bridge, ros-lunar-libg2o, ros-lunar-octomap, ros-lunar-qt-gui-cpp, zlib1g-dev
Description: RTAB-Map's standalone library.
 RTAB-Map is a RGB-D SLAM approach with real-time constraints.
